Attribute VB_Name = "Module1"
Option Explicit

Private Declare Function NetMessageBufferSend Lib "netapi32.dll" _
(ByVal servername As String, _
ByVal msgname As String, _
ByVal fromname As String, _
ByVal Buffer As String, _
ByVal BufSize As Long) As Long

Private Const NERR_SUCCESS As Long = 0
Private Const NERR_BASE As Long = 2100
Private Const NERR_NetworkError As Long = (NERR_BASE + 36)
Private Const NERR_NameNotFound As Long = (NERR_BASE + 173)
Private Const NERR_UseNotFound As Long = (NERR_BASE + 150)
Private Const ERROR_ACCESS_DENIED As Long = 5
Private Const ERROR_BAD_NETPATH As Long = 53
Private Const ERROR_NOT_SUPPORTED As Long = 50
Private Const ERROR_INVALID_PARAMETER As Long = 87
Private Const ERROR_INVALID_NAME As Long = 123


Public Function NetSendMessage(ByVal sSendTo As String, ByVal sMessage As String) As Long
    Dim ret As Long
    
    'conversion of strings
    sSendTo = StrConv(sSendTo, vbUnicode)
    sMessage = StrConv(sMessage, vbUnicode)
    'transmitting message to net comp.
    NetSendMessage = NetMessageBufferSend(vbNullString, sSendTo, vbNullString, _
        sMessage, Len(sMessage))
End Function

'desc. of api err.
Public Function NetSendErrorMessage(ErrNum As Long) As String
    Select Case ErrNum
        Case NERR_SUCCESS
            NetSendErrorMessage = "The message was successfully sent"
        Case NERR_NameNotFound
            NetSendErrorMessage = "Send To not found"
        Case NERR_NetworkError
            NetSendErrorMessage = "General network error occurred"
        Case NERR_UseNotFound
            NetSendErrorMessage = "Network connection not found"
        Case ERROR_ACCESS_DENIED
            NetSendErrorMessage = "Access to computer denied"
        Case ERROR_BAD_NETPATH
            NetSendErrorMessage = "Sent From server name not found."
        Case ERROR_INVALID_PARAMETER
            NetSendErrorMessage = "Invalid parameter(s) specified."
        Case ERROR_NOT_SUPPORTED
            NetSendErrorMessage = "Network request not supported."
        Case ERROR_INVALID_NAME
            NetSendErrorMessage = "Illegal character or malformed name."
        Case Else
            NetSendErrorMessage = "Unknown error executing command."
   End Select
End Function


